# How to build

Galactic assumes that the [ajaxUpload](http://hg.impredicative.com/ajaxUpload/), [gui](http://hg.impredicative.com/gui/), [http://hg.impredicative.com/meta](meta), and [bootstrap](http://web.mit.edu/~phurst/hg/bootstrap/) libraries are installed in `/usr/local/lib/urweb/ur` (or the equivalent); all three of those URLs are Mercurial repositories, so you can just `hg clone` them.

It also requires the latest development version of the Ur/Web compiler, available in Mercurial at `http://hg.impredicative.com/urweb`.

# Setting up a database

Galactic uses PostgreSQL; by default it connects to a server running on localhost with ident authentication. To set it up on Debian, run the following:

    urweb galactic
    sudo aptitude install postgres postgres-client
    sudo -u postgres createuser --createdb $USER
    createdb galactic
    psql -f sql.sql galactic

In order to add teachers/students, try this:

    psql galactic
    INSERT INTO uw_Authentication_userTbl VALUES ('teacher', TRUE);
    INSERT INTO uw_Authentication_userTbl VALUES ('student', FALSE);

If you change the database schema and want to drop all non-authentication tables, do

    select 'drop table if exists "' || tablename || '" cascade;'
      from pg_tables
      where schemaname = 'public' and tablename != 'uw_authentication_usertbl';

and then copy-paste the result back into your terminal, then do `psql -f sql.sql` and ignore the errors (it's trying to re-create sequences).

# Testing the application

After building as described above, start a standalone web server process like so:

    ./galactic.exe

Now you can visit this main entry point URL in a browser:

    http://localhost:8080/Galactic/main

To do much of anything, you'll need to "log in."  For now, we just let anyone declare themselves to be any user via `/Galactic/editUserCookie`!  The options will be whatever you `INSERT`ed into the database like above.  Teachers can do extra admin-y things, naturally, and students can submit homework assignments.

# CSS and JavaScript

The CSS and JS files are in `/css/` and `/js/` respectively. If you want to use your own hosting instead of mine (which you probably should!), you'll need to modify some URLs in `galactic.urp` and `template.ur`.
