con user = [Username = string, Teacher = bool]

cookie userCookie : string

table userTbl : user PRIMARY KEY (Username)

val getUser : transaction (option $user) =
    username <- getCookie userCookie;
    case username of
        None => return None
      | Some u =>
        oneOrNoRows1 (SELECT * FROM userTbl WHERE userTbl.Username = {[u]})

val getUsers : transaction (list $user) =
    queryL1 (SELECT * FROM userTbl ORDER BY userTbl.Username DESC)
val getStudents : transaction (list $user) =
    queryL1 (SELECT * FROM userTbl WHERE NOT userTbl.Teacher
                                     ORDER BY userTbl.Username DESC)

fun ifTeacher (x : xbody) : transaction xbody =
    user <- getUser;
    return (if Option.mp (fn v => v.Teacher) user = Some True
       then x else <xml/>)

fun ifStudent (x : xbody) : transaction xbody =
    user <- getUser;
    return (if Option.mp (fn v => v.Teacher) user = Some False
       then x else <xml/>)

fun withUser [a] (f : $user -> transaction a) : transaction a =
    user <- getUser;
    case user of
        None => error <xml>Unauthorized</xml>
      | Some u => f u

val requireTeacher : transaction unit =
    user <- getUser;
    if Option.mp (fn v => v.Teacher) user = Some True
    then return ()
    else error <xml>Unauthorized</xml>

val requireLogin : transaction unit =
    user <- getUser;
    if Option.isSome user then return () else error <xml>Unauthorized</xml>

fun requireTeacherOr username : transaction unit =
    user <- getUser;
    if Option.mp (fn u => u.Teacher || u.Username = username) user = Some True
    then return ()
    else error <xml>Unauthorized</xml>
