open Util

fun validateAwesomeness x = if x < 0 || x > 100 then Some "Out of bounds"
                            else None

val formEl = Gui.concatForm
                 (Gui.textboxEl [#Description] "Description" "Fill me in"
                                Util.nonEmpty)
                 (Gui.intEl [#Awesomeness] "Awesomeness" 100
                            validateAwesomeness)

structure Mat = Material.Make(struct
    con cols = [Description = string, Awesomeness = int]
    val validate = formEl.Validate
  end)

structure Gui = Mat.Gui(struct
    val name = "Basic Material"
    val viewMaterial = fn _ _ material => return <xml>
      <h2>Description</h2>
      <div>{[material.Description]}</div>
      <div>The awesomeness level of this material is
        {[material.Awesomeness]}.</div>
    </xml>
    val auxHandlers = {}
    val formEl = formEl
  end)

val viewAll = Gui.routed.ViewAll
