open Bootstrap3
structure DT = Datetime
structure JS = DatetimePickerJs

type t = {Id : id, Xml : xbody, Source : source (option DT.t)}

val activ = Basis.active

fun create t =
    id <- fresh;
    src <- source "";
    dtSrc <- source t;
    return { Id = id, Xml = <xml>
      <div class="input-group" id={id}>
        <span class="input-group-addon">
          <span class="glyphicon glyphicon-calendar"></span>
        </span>
        <ctextbox source={src} class="form-control"/>
        <activ code={JS.initialize id (Option.mp DT.toTime t);
                     JS.onChange id (fn t =>
                                        set dtSrc (Option.mp DT.fromTime t));
                     return <xml/>}/>
        </div>
      </xml>,
           Source = dtSrc}

fun onChange picker handler =
    JS.onChange picker.Id (compose handler (Option.mp DT.fromTime))

fun value picker = signal picker.Source

fun render picker = picker.Xml
