open Authentication

structure U = Gui.Upload(struct end)

fun getUpload [a ::: Type] (uploadId : int) : transaction a =
    withUser (fn user =>
    upload <- U.getUpload uploadId;
      case upload of
          None => error <xml>404!</xml>
        | Some upload' => returnBlob upload'.Content (blessMime upload'.MimeType))

val homeworkEl = Gui.textareaEl [#Description] "Description" "An assignment"
                                Util.nonEmpty
val submissionEl = U.uploadEl [#ViewUpload] [#Submission] True

structure Grad = Gradable.Make(struct
    con submissionData = [Submission = option int]
    val validateGradable = homeworkEl.Validate
    val validateSubmission = submissionEl.Validate
  end)

structure Gui = Grad.Gui(struct
    val name = "Homework"
    val viewGradable = fn _ _ homework => return <xml>
      <h2>Description</h2>
      <div>{[homework.Description]}</div>
    </xml>
    val viewSubmission = fn _ _ submission =>
                            case submission.Submission of
                                Some submission' => getUpload submission'
                              | None => error <xml>404</xml>
    val formEls = homeworkEl
    val auxHandlers = {ViewUpload = fn r id => getUpload id}
    val submissionEl = submissionEl
  end)

val viewOne = Gui.routed.ViewOne
val viewAll = Gui.routed.ViewAll
