var DatetimePickerJs = {
  initialize: function(id, time) {
    var picker = $("#" + id);

    // t is either a time in milliseconds since the epoch or null.
    var options = {};
    if (time !== null) {
      // The docs say it takes Date objects, but that doesn't work for some
      // reason.
      options["defaultDate"] = moment(time / 1000);
    }


    $(function() {
      // Initialize the picker.
      picker.datetimepicker(options);
      picker.children("input").on("input", function(event) {
        picker.trigger({type: "dp.change",
                        date: moment(new Date(event.target.value))});
      }).blur(function(event) {
        // When we lose focus, 'set' the date. This just has the effect of
        // canonicalizing the date (i.e., formatting it properly), which can
        // prevent some nasty surprises if the user inputs something like '5' or
        // '5/6'.
        picker.data("DateTimePicker").setDate(moment(new Date(event.target.value)));
      });
    });
  },

  onChange: function(objId, handler) {
    $("#" + objId).on("dp.change", function(e) {
      // Need a double execF here since [option time -> transaction unit] gets
      // treated as [option time -> unit -> unit].

      // e.date is a moment.js object, so convert it to millis since the
      // epoch. If the date is invalid, valueOf() will be NaN.
      var micros = isNaN(e.date.valueOf()) ? null : e.date.valueOf() * 1000;
      execF(execF(handler, micros), null);
    });
  }
};
