structure V = Variant

type router (requires :: {Type}) = variant requires -> url

type handler (requires :: {Type}) (param :: Type) =
     router requires -> param -> transaction page

fun weakenHandler [requires ::: {Type}] [requires' ::: {Type}]
                  [requires ~ requires'] (fl : folder requires)
                  [param ::: Type] (old : handler requires param)
    : handler (requires ++ requires') param  =
 fn r => old (fn x => r (@V.weaken ! fl x))

type handlers (requires :: {Type}) (provides :: {Type}) =
     $(map (handler requires) provides)

type closable (linkage :: {Type}) = handlers linkage linkage

functor Close(M : sig
                  con provides :: {Type}
                  val fl : folder provides
                  val fs : handlers provides provides
              end) : sig
    val routed : $(map (fn t => t -> transaction page) M.provides)
end
  = struct
    fun page (v : variant M.provides) : transaction page =
        match v (routed' ())

    and routed' () = (@mp [fn t => handler M.provides t]
                   [fn t => t -> transaction page]
                   (fn [t :::_] v => v (fn x => url (page x)))
                   M.fl M.fs)

    val routed = routed' ()
end

fun weaken [requires ::: {Type}] [unused ::: {Type}] [provides ::: {Type}]
           [requires ~ unused] (fl : folder provides) (fl2 : folder requires)
           (fs : handlers requires provides)  =
    @mp [handler requires] [handler (requires ++ unused)]
     (fn [u] f => @weakenHandler ! fl2 f) fl fs
