structure U = Gui.Upload(struct end)

val materialEl = U.uploadEl [#ViewUpload] [#Reading] True

structure Mat = Material.Make(struct
    con cols = [Reading = option int]
    val validate = materialEl.Validate
  end)

fun getUpload (uploadId : int) : transaction page =
    upload <- U.getUpload uploadId;
    case upload of
        None => error <xml>No such upload</xml>
      | Some upload' => returnBlob upload'.Content
                        (blessMime upload'.MimeType)

structure Gui = Mat.Gui(struct
    val name = "Reading Material"
    val viewMaterial = fn r _ material => return (
    case material.Reading of
        Some id => <xml>
          <div><a href={r (make [#ViewUpload] id)}>
            Get material
          </a></div>
        </xml>
      | None => <xml/>)
    val auxHandlers = {ViewUpload = fn _ => getUpload}
    val formEl = materialEl
  end)

val viewAll = Gui.routed.ViewAll
