open Bootstrap3
open Util

fun saveButton [a] enable extract (handler : a -> transaction unit) onSave
    : transaction xbody =
    id <- fresh;
    return <xml>
      <button data-loading-text="Saving..." id={id} dynClass={
    enabled <- enable;
    return (classes (if enabled then null else CLASS "disabled")
                    (CLASS "btn btn-primary"))}
      onclick={fn _ =>
                  v <- extract;
                  BootstrapJs.setLoading id True;
                  (case v of
                      Util.Error err => alert err
                    | Util.Success v' => handler v'; onSave);
                  BootstrapJs.setLoading id False}
        value="Save"/>
</xml>

fun formElSaveButton [routes] [meta] [fs] [state] [xtype] element state handler
    : transaction xbody =
    saveButton (Monad.mp isSuccess (element.Signals state))
               (current (element.Signals state))
               (handler : $fs -> transaction unit) (element.OnSave state)
