(* Create a save button given how to determine whether it's enabled, how to
   extract the data to be saved, the handler for saved data, and what to do
   after a save. *)

val saveButton : a ::: Type -> signal bool -> transaction (Util.result a) ->
                 (a -> transaction unit) -> transaction unit ->
                 transaction xbody

(* Create a save button out of a form element, its state, and the server-side
   handler. *)
val formElSaveButton : routes ::: {Type} -> meta ::: Type -> fs ::: {Type} ->
                       state ::: Type -> ctx ::: {Unit} ->
                       Gui.formElement routes meta fs state ctx ->
                       state -> ($fs -> transaction unit) ->
                       transaction xbody
